Перем КаталогиТиповМетаданных;
Перем КаталогиТиповМетаданныхДляТестов;

// КаталогиТиповМетаданных
//  Возвращает список имен каталогов и типов метаданных в них.
// Возвращаемое значение:
//	СписокЗначений - Список каталогов
//		* Значение - Строка - Имя каталога
//		* Представление - Срока - Имя типа метаданных
Функция КаталогиТиповМетаданных(edt = Ложь) Экспорт
	
	Если КаталогиТиповМетаданных = Неопределено Тогда
		
		КаталогиТиповМетаданных = Новый СписокЗначений();
		КаталогиТиповМетаданных.Добавить("AccountingRegisters", "AccountingRegister");
		КаталогиТиповМетаданных.Добавить("AccumulationRegisters", "AccumulationRegister");
		КаталогиТиповМетаданных.Добавить("Bots", "Bot");
		КаталогиТиповМетаданных.Добавить("BusinessProcesses", "BusinessProcess");
		КаталогиТиповМетаданных.Добавить("Catalogs", "Catalog");
		КаталогиТиповМетаданных.Добавить("ChartsOfAccounts", "ChartOfAccounts");
		КаталогиТиповМетаданных.Добавить("ChartsOfCalculationTypes", "ChartOfCalculationTypes");
		КаталогиТиповМетаданных.Добавить("ChartsOfCharacteristicTypes", "ChartOfCharacteristicTypes");
		КаталогиТиповМетаданных.Добавить("CalculationRegisters", "CalculationRegister");
		КаталогиТиповМетаданных.Добавить("CommandGroups", "CommandGroup");
		КаталогиТиповМетаданных.Добавить("CommonAttributes", "CommonAttribute");
		КаталогиТиповМетаданных.Добавить("CommonCommands", "CommonCommand");
		КаталогиТиповМетаданных.Добавить("CommonForms", "CommonForm");
		КаталогиТиповМетаданных.Добавить("CommonModules", "CommonModule");
		КаталогиТиповМетаданных.Добавить("CommonPictures", "CommonPicture");
		КаталогиТиповМетаданных.Добавить("CommonTemplates", "CommonTemplate");
		КаталогиТиповМетаданных.Добавить("Constants", "Constant");
		КаталогиТиповМетаданных.Добавить("DataProcessors", "DataProcessor");
		КаталогиТиповМетаданных.Добавить("DefinedTypes", "DefinedType");
		КаталогиТиповМетаданных.Добавить("DocumentJournals", "DocumentJournal");
		КаталогиТиповМетаданных.Добавить("DocumentNumerators", "DocumentNumerator");
		КаталогиТиповМетаданных.Добавить("Documents", "Document");
		КаталогиТиповМетаданных.Добавить("Enums", "Enum");
		КаталогиТиповМетаданных.Добавить("EventSubscriptions", "EventSubscription");
		КаталогиТиповМетаданных.Добавить("ExchangePlans", "ExchangePlan");
		КаталогиТиповМетаданных.Добавить("ExternalDataSources", "ExternalDataSource");
		КаталогиТиповМетаданных.Добавить("FilterCriteria", "FilterCriterion");
		КаталогиТиповМетаданных.Добавить("FunctionalOptions", "FunctionalOption");
		КаталогиТиповМетаданных.Добавить("FunctionalOptionsParameters", "FunctionalOptionsParameter");
		КаталогиТиповМетаданных.Добавить("HTTPServices", "HTTPService");
		КаталогиТиповМетаданных.Добавить("InformationRegisters", "InformationRegister");
		КаталогиТиповМетаданных.Добавить("Reports", "Report");
		КаталогиТиповМетаданных.Добавить("Roles", "Role");
		КаталогиТиповМетаданных.Добавить("ScheduledJobs", "ScheduledJob");
		КаталогиТиповМетаданных.Добавить("SessionParameters", "SessionParameter");
		КаталогиТиповМетаданных.Добавить("SettingsStorages", "SettingsStorage");
		КаталогиТиповМетаданных.Добавить("StyleItems", "StyleItem");
		КаталогиТиповМетаданных.Добавить("Sequences", "Sequence");
		КаталогиТиповМетаданных.Добавить("Styles", "Style");
		КаталогиТиповМетаданных.Добавить("Subsystems", "Subsystem");
		КаталогиТиповМетаданных.Добавить("Tasks", "Task");
		КаталогиТиповМетаданных.Добавить("WebServices", "WebService");
		КаталогиТиповМетаданных.Добавить("WSReferences", "WSReference");
		КаталогиТиповМетаданных.Добавить("XDTOPackages", "XDTOPackage");
		
		Если НЕ edt Тогда
			КаталогиТиповМетаданных.Добавить("Languages", "Language");		
		КонецЕсли;
	
	КонецЕсли;
	
	Возврат КаталогиТиповМетаданных;
	
КонецФункции

// КаталогиТиповМетаданныхДляТестов
//  Возвращает список имен каталогов типов метаданных, для которых генерируются тесты, и их краткие представления.
// Возвращаемое значение:
//	СписокЗначений - Список каталогов
//		* Значение - Строка - Имя каталога
//		* Представление - Срока - Краткое представление
Функция КаталогиТиповМетаданныхДляТестов() Экспорт
	
	Если КаталогиТиповМетаданныхДляТестов = Неопределено Тогда
		
		КаталогиТиповМетаданныхДляТестов = Новый СписокЗначений();
		КаталогиТиповМетаданныхДляТестов.Добавить("AccountingRegisters", "РБ");
		КаталогиТиповМетаданныхДляТестов.Добавить("AccumulationRegisters", "РН");
		КаталогиТиповМетаданныхДляТестов.Добавить("BusinessProcesses", "БП");
		КаталогиТиповМетаданныхДляТестов.Добавить("CalculationRegisters", "РР");
		КаталогиТиповМетаданныхДляТестов.Добавить("Catalogs", "Спр");
		КаталогиТиповМетаданныхДляТестов.Добавить("ChartsOfAccounts", "ПС");
		КаталогиТиповМетаданныхДляТестов.Добавить("ChartsOfCalculationTypes", "ПВР");
		КаталогиТиповМетаданныхДляТестов.Добавить("ChartsOfCharacteristicTypes", "ПВХ");
		КаталогиТиповМетаданныхДляТестов.Добавить("CommonModules", "ОМ");
		КаталогиТиповМетаданныхДляТестов.Добавить("DataProcessors", "Обр");
		КаталогиТиповМетаданныхДляТестов.Добавить("Documents", "Док");
		КаталогиТиповМетаданныхДляТестов.Добавить("Enums", "Пер");
		КаталогиТиповМетаданныхДляТестов.Добавить("ExchangePlans", "ПО");
		КаталогиТиповМетаданныхДляТестов.Добавить("InformationRegisters", "РС");
		КаталогиТиповМетаданныхДляТестов.Добавить("Reports", "Отч");
		КаталогиТиповМетаданныхДляТестов.Добавить("Tasks", "Зад");
		
	КонецЕсли;
	
	Возврат КаталогиТиповМетаданныхДляТестов;
	
КонецФункции

Процедура СброситьКеш() Экспорт
	КаталогиТиповМетаданныхДляТестов = Неопределено;
	КаталогиТиповМетаданных = Неопределено;
КонецПроцедуры